ActiveResource::Base is the main class for mapping RESTful resources as models in a Rails application.

For an outline of what Active Resource is capable of, see its README.

Automated mapping

Active Resource objects represent your RESTful resources as manipulatable Ruby objects. To map resources to Ruby objects, Active Resource only needs a class name that corresponds to the resource name (e.g., the class Person maps to the resources people, very similarly to Active Record) and a site value, which holds the URI of the resources.

  class Person < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
  end

Now the Person class is mapped to RESTful resources located at api.people.com:3000/people/, and you can now use Active Resource’s life cycle methods to manipulate resources. In the case where you already have an existing model with the same name as the desired RESTful resource you can set the element_name value.

  class PersonResource < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
    self.element_name = "person"
  end

If your Active Resource object is required to use an HTTP proxy you can set the proxy value which holds a URI.

  class PersonResource < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
    self.proxy = "http://user:password@proxy.people.com:8080"
  end

Life cycle methods

Active Resource exposes methods for creating, finding, updating, and deleting resources from REST web services.

  ryan = Person.new(:first => 'Ryan', :last => 'Daigle')
  ryan.save                # => true
  ryan.id                  # => 2
  Person.exists?(ryan.id)  # => true
  ryan.exists?             # => true

  ryan = Person.find(1)
  # Resource holding our newly created Person object

  ryan.first = 'Rizzle'
  ryan.save                # => true

  ryan.destroy             # => true

As you can see, these are very similar to Active Record’s life cycle methods for database records. You can read more about each of these methods in their respective documentation.

Custom REST methods

Since simple CRUD/life cycle methods can’t accomplish every task, Active Resource also supports defining your own custom REST methods. To invoke them, Active Resource provides the get, post, put and delete methods where you can specify a custom REST method name to invoke.

  # POST to the custom 'register' REST method, i.e. POST /people/new/register.xml.
  Person.new(:name => 'Ryan').post(:register)
  # => { :id => 1, :name => 'Ryan', :position => 'Clerk' }

  # PUT an update by invoking the 'promote' REST method, i.e. PUT /people/1/promote.xml?position=Manager.
  Person.find(1).put(:promote, :position => 'Manager')
  # => { :id => 1, :name => 'Ryan', :position => 'Manager' }

  # GET all the positions available, i.e. GET /people/positions.xml.
  Person.get(:positions)
  # => [{:name => 'Manager'}, {:name => 'Clerk'}]

  # DELETE to 'fire' a person, i.e. DELETE /people/1/fire.xml.
  Person.find(1).delete(:fire)

For more information on using custom REST methods, see the ActiveResource::CustomMethods documentation.

Validations

You can validate resources client side by overriding validation methods in the base class.

  class Person < ActiveResource::Base
     self.site = "http://api.people.com:3000/"
     protected
       def validate
         errors.add("last", "has invalid characters") unless last =~ /[a-zA-Z]*/
       end
  end

See the ActiveResource::Validations documentation for more information.

Authentication

Many REST APIs will require authentication, usually in the form of basic HTTP authentication. Authentication can be specified by:

HTTP Basic Authentication

  • putting the credentials in the URL for the site variable.

     class Person < ActiveResource::Base
       self.site = "http://ryan:password@api.people.com:3000/"
     end
    
  • defining user and/or password variables

     class Person < ActiveResource::Base
       self.site = "http://api.people.com:3000/"
       self.user = "ryan"
       self.password = "password"
     end
    

For obvious security reasons, it is probably best if such services are available over HTTPS.

Note: Some values cannot be provided in the URL passed to site. e.g. email addresses as usernames. In those situations you should use the separate user and password option.

Certificate Authentication

  • End point uses an X509 certificate for authentication. See ssl_options= for all options.

     class Person < ActiveResource::Base
       self.site = "https://secure.api.people.com/"
       self.ssl_options = {:cert         => OpenSSL::X509::Certificate.new(File.open(pem_file))
                           :key          => OpenSSL::PKey::RSA.new(File.open(pem_file)),
                           :ca_path      => "/path/to/OpenSSL/formatted/CA_Certs",
                           :verify_mode  => OpenSSL::SSL::VERIFY_PEER}
     end
    

Errors & Validation

Error handling and validation is handled in much the same manner as you’re used to seeing in Active Record. Both the response code in the HTTP response and the body of the response are used to indicate that an error occurred.

Resource errors

When a GET is requested for a resource that does not exist, the HTTP 404 (Resource Not Found) response code will be returned from the server which will raise an ActiveResource::ResourceNotFound exception.

  # GET http://api.people.com:3000/people/999.xml
  ryan = Person.find(999) # 404, raises ActiveResource::ResourceNotFound

404 is just one of the HTTP error response codes that Active Resource will handle with its own exception. The following HTTP response codes will also result in these exceptions:

These custom exceptions allow you to deal with resource errors more naturally and with more precision rather than returning a general HTTP error. For example:

  begin
    ryan = Person.find(my_id)
  rescue ActiveResource::ResourceNotFound
    redirect_to :action => 'not_found'
  rescue ActiveResource::ResourceConflict, ActiveResource::ResourceInvalid
    redirect_to :action => 'new'
  end

Validation errors

Active Resource supports validations on resources and will return errors if any of these validations fail (e.g., “First name can not be blank” and so on). These types of errors are denoted in the response by a response code of 422 and an XML or JSON representation of the validation errors. The save operation will then fail (with a false return value) and the validation errors can be accessed on the resource in question.

  ryan = Person.find(1)
  ryan.first # => ''
  ryan.save  # => false

  # When
  # PUT http://api.people.com:3000/people/1.xml
  # or
  # PUT http://api.people.com:3000/people/1.json
  # is requested with invalid values, the response is:
  #
  # Response (422):
  # <errors><error>First cannot be empty</error></errors>
  # or
  # {"errors":["First cannot be empty"]}
  #

  ryan.errors.invalid?(:first)  # => true
  ryan.errors.full_messages     # => ['First cannot be empty']

Learn more about Active Resource’s validation features in the ActiveResource::Validations documentation.

Timeouts

Active Resource relies on HTTP to access RESTful APIs and as such is inherently susceptible to slow or unresponsive servers. In such cases, your Active Resource method calls could timeout. You can control the amount of time before Active Resource times out with the timeout variable.

  class Person < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
    self.timeout = 5
  end

This sets the timeout to 5 seconds. You can adjust the timeout to a value suitable for the RESTful API you are accessing. It is recommended to set this to a reasonably low value to allow your Active Resource clients (especially if you are using Active Resource in a Rails application) to fail-fast (see en.wikipedia.org/wiki/Fail-fast) rather than cause cascading failures that could incapacitate your server.

When a timeout occurs, an ActiveResource::TimeoutError is raised. You should rescue from ActiveResource::TimeoutError in your Active Resource method calls.

Internally, Active Resource relies on Ruby’s Net::HTTP library to make HTTP requests. Setting timeout sets the read_timeout of the internal Net::HTTP instance to the same value. The default read_timeout is 60 seconds on most Ruby implementations.

Methods
Included Modules
Public Class methods
all(*args)

This is an alias for find(:all). You can pass in all the same arguments to this method as you can to find(:all)

       # File activeresource/lib/active_resource/base.rb, line 802
802:       def all(*args)
803:         find(:all, *args)
804:       end
auth_type()
       # File activeresource/lib/active_resource/base.rb, line 459
459:       def auth_type
460:         if defined?(@auth_type)
461:           @auth_type
462:         end
463:       end
auth_type=(auth_type)
       # File activeresource/lib/active_resource/base.rb, line 465
465:       def auth_type=(auth_type)
466:         @connection = nil
467:         @auth_type = auth_type
468:       end
build(attributes = {})

Builds a new, unsaved record using the default values from the remote server so that it can be used with RESTful forms.

Options

  • attributes - A hash that overrides the default values from the server.

Returns the new resource instance.

       # File activeresource/lib/active_resource/base.rb, line 680
680:       def build(attributes = {})
681:         attrs = connection.get("#{new_element_path}").merge(attributes)
682:         self.new(attrs)
683:       end
collection_path(prefix_options = {}, query_options = nil)

Gets the collection path for the REST resources. If the query_options parameter is omitted, Rails will split from the prefix_options.

Options

  • prefix_options - A hash to add a prefix to the request for nested URLs (e.g., :account_id => 19 would yield a URL like /accounts/19/purchases.xml).

  • query_options - A hash to add items to the query string for the request.

Examples

  Post.collection_path
  # => /posts.xml

  Comment.collection_path(:post_id => 5)
  # => /posts/5/comments.xml

  Comment.collection_path(:post_id => 5, :active => 1)
  # => /posts/5/comments.xml?active=1

  Comment.collection_path({:post_id => 5}, {:active => 1})
  # => /posts/5/comments.xml?active=1
       # File activeresource/lib/active_resource/base.rb, line 665
665:       def collection_path(prefix_options = {}, query_options = nil)
666:         prefix_options, query_options = split_options(prefix_options) if query_options.nil?
667:         "#{prefix(prefix_options)}#{collection_name}.#{format.extension}#{query_string(query_options)}"
668:       end
connection(refresh = false)

An instance of ActiveResource::Connection that is the base connection to the remote service. The refresh parameter toggles whether or not the connection is refreshed at every request or not (defaults to false).

       # File activeresource/lib/active_resource/base.rb, line 535
535:       def connection(refresh = false)
536:         if defined?(@connection) || superclass == Object
537:           @connection = Connection.new(site, format) if refresh || @connection.nil?
538:           @connection.proxy = proxy if proxy
539:           @connection.user = user if user
540:           @connection.password = password if password
541:           @connection.auth_type = auth_type if auth_type
542:           @connection.timeout = timeout if timeout
543:           @connection.ssl_options = ssl_options if ssl_options
544:           @connection
545:         else
546:           superclass.connection
547:         end
548:       end
create(attributes = {})

Creates a new resource instance and makes a request to the remote service that it be saved, making it equivalent to the following simultaneous calls:

  ryan = Person.new(:first => 'ryan')
  ryan.save

Returns the newly created resource. If a failure has occurred an exception will be raised (see save). If the resource is invalid and has not been saved then valid? will return false, while new? will still return true.

Examples

  Person.create(:name => 'Jeremy', :email => 'myname@nospam.com', :enabled => true)
  my_person = Person.find(:first)
  my_person.email # => myname@nospam.com

  dhh = Person.create(:name => 'David', :email => 'dhh@nospam.com', :enabled => true)
  dhh.valid? # => true
  dhh.new?   # => false

  # We'll assume that there's a validation that requires the name attribute
  that_guy = Person.create(:name => '', :email => 'thatguy@nospam.com', :enabled => true)
  that_guy.valid? # => false
  that_guy.new?   # => true
       # File activeresource/lib/active_resource/base.rb, line 709
709:       def create(attributes = {})
710:         self.new(attributes).tap { |resource| resource.save }
711:       end
delete(id, options = {})

Deletes the resources with the ID in the id parameter.

Options

All options specify prefix and query parameters.

Examples

  Event.delete(2) # sends DELETE /events/2

  Event.create(:name => 'Free Concert', :location => 'Community Center')
  my_event = Event.find(:first) # let's assume this is event with ID 7
  Event.delete(my_event.id) # sends DELETE /events/7

  # Let's assume a request to events/5/cancel.xml
  Event.delete(params[:id]) # sends DELETE /events/5
       # File activeresource/lib/active_resource/base.rb, line 821
821:       def delete(id, options = {})
822:         connection.delete(element_path(id, options))
823:       end
element_path(id, prefix_options = {}, query_options = nil)

Gets the element path for the given ID in id. If the query_options parameter is omitted, Rails will split from the prefix options.

Options

prefix_options - A hash to add a prefix to the request for nested URLs (e.g., :account_id => 19

                   would yield a URL like <tt>/accounts/19/purchases.xml</tt>).

query_options - A hash to add items to the query string for the request.

Examples

  Post.element_path(1)
  # => /posts/1.xml

  Comment.element_path(1, :post_id => 5)
  # => /posts/5/comments/1.xml

  Comment.element_path(1, :post_id => 5, :active => 1)
  # => /posts/5/comments/1.xml?active=1

  Comment.element_path(1, {:post_id => 5}, {:active => 1})
  # => /posts/5/comments/1.xml?active=1
       # File activeresource/lib/active_resource/base.rb, line 623
623:       def element_path(id, prefix_options = {}, query_options = nil)
624:         prefix_options, query_options = split_options(prefix_options) if query_options.nil?
625:         "#{prefix(prefix_options)}#{collection_name}/#{URI.escape id.to_s}.#{format.extension}#{query_string(query_options)}"
626:       end
exists?(id, options = {})

Asserts the existence of a resource, returning true if the resource is found.

Examples

  Note.create(:title => 'Hello, world.', :body => 'Nothing more for now...')
  Note.exists?(1) # => true

  Note.exists(1349) # => false
       # File activeresource/lib/active_resource/base.rb, line 832
832:       def exists?(id, options = {})
833:         if id
834:           prefix_options, query_options = split_options(options[:params])
835:           path = element_path(id, prefix_options, query_options)
836:           response = connection.head(path, headers)
837:           response.code.to_i == 200
838:         end
839:         # id && !find_single(id, options).nil?
840:       rescue ActiveResource::ResourceNotFound, ActiveResource::ResourceGone
841:         false
842:       end
find(*arguments)

Core method for finding resources. Used similarly to Active Record’s find method.

Arguments

The first argument is considered to be the scope of the query. That is, how many resources are returned from the request. It can be one of the following.

  • :one - Returns a single resource.

  • :first - Returns the first resource found.

  • :last - Returns the last resource found.

  • :all - Returns every resource that matches the request.

Options

  • :from - Sets the path or custom method that resources will be fetched from.

  • :params - Sets query and prefix (nested URL) parameters.

Examples

  Person.find(1)
  # => GET /people/1.xml

  Person.find(:all)
  # => GET /people.xml

  Person.find(:all, :params => { :title => "CEO" })
  # => GET /people.xml?title=CEO

  Person.find(:first, :from => :managers)
  # => GET /people/managers.xml

  Person.find(:last, :from => :managers)
  # => GET /people/managers.xml

  Person.find(:all, :from => "/companies/1/people.xml")
  # => GET /companies/1/people.xml

  Person.find(:one, :from => :leader)
  # => GET /people/leader.xml

  Person.find(:all, :from => :developers, :params => { :language => 'ruby' })
  # => GET /people/developers.xml?language=ruby

  Person.find(:one, :from => "/companies/1/manager.xml")
  # => GET /companies/1/manager.xml

  StreetAddress.find(1, :params => { :person_id => 1 })
  # => GET /people/1/street_addresses/1.xml

Failure or missing data

  A failure to find the requested object raises a ResourceNotFound
  exception if the find was called with an id.
  With any other scope, find returns nil when no data is returned.

  Person.find(1)
  # => raises ResourceNotFound

  Person.find(:all)
  Person.find(:first)
  Person.find(:last)
  # => nil
       # File activeresource/lib/active_resource/base.rb, line 772
772:       def find(*arguments)
773:         scope   = arguments.slice!(0)
774:         options = arguments.slice!(0) || {}
775: 
776:         case scope
777:           when :all   then find_every(options)
778:           when :first then find_every(options).first
779:           when :last  then find_every(options).last
780:           when :one   then find_one(options)
781:           else             find_single(scope, options)
782:         end
783:       end
first(*args)

A convenience wrapper for find(:first, *args). You can pass in all the same arguments to this method as you can to find(:first).

       # File activeresource/lib/active_resource/base.rb, line 789
789:       def first(*args)
790:         find(:first, *args)
791:       end
format()

Returns the current format, default is ActiveResource::Formats::XmlFormat.

       # File activeresource/lib/active_resource/base.rb, line 488
488:       def format
489:         read_inheritable_attribute(:format) || ActiveResource::Formats::XmlFormat
490:       end
format=(mime_type_reference_or_format)

Sets the format that attributes are sent and received in from a mime type reference:

  Person.format = :json
  Person.find(1) # => GET /people/1.json

  Person.format = ActiveResource::Formats::XmlFormat
  Person.find(1) # => GET /people/1.xml

Default format is :xml.

       # File activeresource/lib/active_resource/base.rb, line 479
479:       def format=(mime_type_reference_or_format)
480:         format = mime_type_reference_or_format.is_a?(Symbol) ?
481:           ActiveResource::Formats[mime_type_reference_or_format] : mime_type_reference_or_format
482: 
483:         write_inheritable_attribute(:format, format)
484:         connection.format = format if site
485:       end
headers()
       # File activeresource/lib/active_resource/base.rb, line 550
550:       def headers
551:         @headers ||= {}
552:       end
known_attributes()

Returns the list of known attributes for this resource, gathered from the provided schema Attributes that are known will cause your resource to return ‘true’ when respond_to? is called on them. A known attribute will return nil if not set (rather than MethodNotFound); thus known attributes can be used with validates_presence_of without a getter-method.

       # File activeresource/lib/active_resource/base.rb, line 369
369:       def known_attributes
370:         @known_attributes ||= []
371:       end
last(*args)

A convenience wrapper for find(:last, *args). You can pass in all the same arguments to this method as you can to find(:last).

       # File activeresource/lib/active_resource/base.rb, line 796
796:       def last(*args)
797:         find(:last, *args)
798:       end
logger

The logger for diagnosing and tracing Active Resource calls.

       # File activeresource/lib/active_resource/base.rb, line 252
252:     cattr_accessor :logger
new(attributes = {})

Constructor method for new resources; the optional attributes parameter takes a hash of attributes for the new resource.

Examples

  my_course = Course.new
  my_course.name = "Western Civilization"
  my_course.lecturer = "Don Trotter"
  my_course.save

  my_other_course = Course.new(:name => "Philosophy: Reason and Being", :lecturer => "Ralph Cling")
  my_other_course.save
       # File activeresource/lib/active_resource/base.rb, line 962
962:     def initialize(attributes = {})
963:       @attributes     = {}.with_indifferent_access
964:       @prefix_options = {}
965:       load(attributes)
966:     end
new_element_path(prefix_options = {})

Gets the new element path for REST resources.

Options

  • prefix_options - A hash to add a prefix to the request for nested URLs (e.g., :account_id => 19 would yield a URL like /accounts/19/purchases/new.xml).

Examples

  Post.new_element_path
  # => /posts/new.xml

  Comment.collection_path(:post_id => 5)
  # => /posts/5/comments/new.xml
       # File activeresource/lib/active_resource/base.rb, line 640
640:       def new_element_path(prefix_options = {})
641:         "#{prefix(prefix_options)}#{collection_name}/new.#{format.extension}"
642:       end
password()

Gets the password for REST HTTP authentication.

       # File activeresource/lib/active_resource/base.rb, line 444
444:       def password
445:         # Not using superclass_delegating_reader. See +site+ for explanation
446:         if defined?(@password)
447:           @password
448:         elsif superclass != Object && superclass.password
449:           superclass.password.dup.freeze
450:         end
451:       end
password=(password)

Sets the password for REST HTTP authentication.

       # File activeresource/lib/active_resource/base.rb, line 454
454:       def password=(password)
455:         @connection = nil
456:         @password = password
457:       end
prefix(options={})

Gets the prefix for a resource’s nested URL (e.g., prefix/collectionname/1.xml) This method is regenerated at runtime based on what the prefix is set to.

       # File activeresource/lib/active_resource/base.rb, line 561
561:       def prefix(options={})
562:         default = site.path
563:         default << '/' unless default[1..1] == '/'
564:         # generate the actual method based on the current site path
565:         self.prefix = default
566:         prefix(options)
567:       end
prefix=(value = '/')

Sets the prefix for a resource’s nested URL (e.g., prefix/collectionname/1.xml). Default value is site.path.

This method is also aliased as set_prefix
       # File activeresource/lib/active_resource/base.rb, line 578
578:       def prefix=(value = '/')
579:         # Replace :placeholders with '#{embedded options[:lookups]}'
580:         prefix_call = value.gsub(/:\w+/) { |key| "\#{URI.escape options[#{key}].to_s}" }
581: 
582:         # Clear prefix parameters in case they have been cached
583:         @prefix_parameters = nil
584: 
585:         silence_warnings do
586:           # Redefine the new methods.
587:           instance_eval             def prefix_source() "#{value}" end            def prefix(options={}) "#{prefix_call}" end, __FILE__, __LINE__ + 1
588:         end
589:       rescue
590:         logger.error "Couldn't set prefix: #{$!}\n  #{code}" if logger
591:         raise
592:       end
prefix_source()

An attribute reader for the source string for the resource path prefix. This method is regenerated at runtime based on what the prefix is set to.

       # File activeresource/lib/active_resource/base.rb, line 571
571:       def prefix_source
572:         prefix # generate #prefix and #prefix_source methods first
573:         prefix_source
574:       end
proxy()

Gets the proxy variable if a proxy is required

       # File activeresource/lib/active_resource/base.rb, line 412
412:       def proxy
413:         # Not using superclass_delegating_reader. See +site+ for explanation
414:         if defined?(@proxy)
415:           @proxy
416:         elsif superclass != Object && superclass.proxy
417:           superclass.proxy.dup.freeze
418:         end
419:       end
proxy=(proxy)

Sets the URI of the http proxy to the value in the proxy argument.

       # File activeresource/lib/active_resource/base.rb, line 422
422:       def proxy=(proxy)
423:         @connection = nil
424:         @proxy = proxy.nil? ? nil : create_proxy_uri_from(proxy)
425:       end
schema(&block)

Creates a schema for this resource - setting the attributes that are known prior to fetching an instance from the remote system.

The schema helps define the set of known_attributes of the current resource.

There is no need to specify a schema for your Active Resource. If you do not, the known_attributes will be guessed from the instance attributes returned when an instance is fetched from the remote system.

example: class Person < ActiveResource::Base

  schema do
    # define each attribute separately
    attribute 'name', :string

    # or use the convenience methods and pass >=1 attribute names
    string  'eye_colour', 'hair_colour'
    integer 'age'
    float   'height', 'weight'

    # unsupported types should be left as strings
    # overload the accessor methods if you need to convert them
    attribute 'created_at', 'string'
  end

end

p = Person.new p.respond_to? :name # => true p.respond_to? :age # => true p.name # => nil p.age # => nil

j = Person.find_by_name(‘John’) # John343 j.respond_to? :name # => true j.respond_to? :age # => true j.name # => ‘John’ j.age # => ‘34’ # note this is a string! j.num_children # => ‘3’ # note this is a string!

p.num_children # => NoMethodError

Attribute-types must be one of:

 string, integer, float

Note: at present the attribute-type doesn’t do anything, but stay tuned... Shortly it will also cast the value of the returned attribute. ie: j.age # => 34 # cast to an integer j.weight # => ‘65’ # still a string!

       # File activeresource/lib/active_resource/base.rb, line 308
308:       def schema(&block)
309:         if block_given?
310:           schema_definition = Schema.new
311:           schema_definition.instance_eval(&block)
312: 
313:           # skip out if we didn't define anything
314:           return unless schema_definition.attrs.present?
315: 
316:           @schema ||= {}.with_indifferent_access
317:           @known_attributes ||= []
318: 
319:           schema_definition.attrs.each do |k,v|
320:             @schema[k] = v
321:             @known_attributes << k
322:           end
323: 
324:           schema
325:         else
326:           @schema ||= nil
327:         end
328:       end
schema=(the_schema)

Alternative, direct way to specify a schema for this Resource. schema is more flexible, but this is quick for a very simple schema.

Pass the schema as a hash with the keys being the attribute-names and the value being one of the accepted attribute types (as defined in schema)

example:

class Person < ActiveResource::Base

  schema = {'name' => :string, 'age' => :integer }

end

The keys/values can be strings or symbols. They will be converted to strings.

       # File activeresource/lib/active_resource/base.rb, line 347
347:       def schema=(the_schema)
348:         unless the_schema.present?
349:           # purposefully nulling out the schema
350:           @schema = nil
351:           @known_attributes = []
352:           return
353:         end
354: 
355:         raise ArgumentError, "Expected a hash" unless the_schema.kind_of? Hash
356: 
357:         schema do
358:           the_schema.each {|k,v| attribute(k,v) }
359:         end
360:       end
site()

Gets the URI of the REST resources to map for this class. The site variable is required for Active Resource’s mapping to work.

       # File activeresource/lib/active_resource/base.rb, line 375
375:       def site
376:         # Not using superclass_delegating_reader because don't want subclasses to modify superclass instance
377:         #
378:         # With superclass_delegating_reader
379:         #
380:         #   Parent.site = 'http://anonymous@test.com'
381:         #   Subclass.site # => 'http://anonymous@test.com'
382:         #   Subclass.site.user = 'david'
383:         #   Parent.site # => 'http://david@test.com'
384:         #
385:         # Without superclass_delegating_reader (expected behaviour)
386:         #
387:         #   Parent.site = 'http://anonymous@test.com'
388:         #   Subclass.site # => 'http://anonymous@test.com'
389:         #   Subclass.site.user = 'david' # => TypeError: can't modify frozen object
390:         #
391:         if defined?(@site)
392:           @site
393:         elsif superclass != Object && superclass.site
394:           superclass.site.dup.freeze
395:         end
396:       end
site=(site)

Sets the URI of the REST resources to map for this class to the value in the site argument. The site variable is required for Active Resource’s mapping to work.

       # File activeresource/lib/active_resource/base.rb, line 400
400:       def site=(site)
401:         @connection = nil
402:         if site.nil?
403:           @site = nil
404:         else
405:           @site = create_site_uri_from(site)
406:           @user = uri_parser.unescape(@site.user) if @site.user
407:           @password = uri_parser.unescape(@site.password) if @site.password
408:         end
409:       end
ssl_options()

Returns the SSL options hash.

       # File activeresource/lib/active_resource/base.rb, line 524
524:       def ssl_options
525:         if defined?(@ssl_options)
526:           @ssl_options
527:         elsif superclass != Object && superclass.ssl_options
528:           superclass.ssl_options
529:         end
530:       end
ssl_options=(opts={})

Options that will get applied to an SSL connection.

  • :key - An OpenSSL::PKey::RSA or OpenSSL::PKey::DSA object.

  • :cert - An OpenSSL::X509::Certificate object as client certificate

  • :ca_file - Path to a CA certification file in PEM format. The file can contrain several CA certificates.

  • :ca_path - Path of a CA certification directory containing certifications in PEM format.

  • :verify_mode - Flags for server the certification verification at begining of SSL/TLS session. (OpenSSL::SSL::VERIFY_NONE or OpenSSL::SSL::VERIFY_PEER is acceptable)

  • :verify_callback - The verify callback for the server certification verification.

  • :verify_depth - The maximum depth for the certificate chain verification.

  • :cert_store - OpenSSL::X509::Store to verify peer certificate.

  • :ssl_timeout -The SSL timeout in seconds.

       # File activeresource/lib/active_resource/base.rb, line 518
518:       def ssl_options=(opts={})
519:         @connection   = nil
520:         @ssl_options  = opts
521:       end
timeout()

Gets the number of seconds after which requests to the REST API should time out.

       # File activeresource/lib/active_resource/base.rb, line 499
499:       def timeout
500:         if defined?(@timeout)
501:           @timeout
502:         elsif superclass != Object && superclass.timeout
503:           superclass.timeout
504:         end
505:       end
timeout=(timeout)

Sets the number of seconds after which requests to the REST API should time out.

       # File activeresource/lib/active_resource/base.rb, line 493
493:       def timeout=(timeout)
494:         @connection = nil
495:         @timeout = timeout
496:       end
user()

Gets the user for REST HTTP authentication.

       # File activeresource/lib/active_resource/base.rb, line 428
428:       def user
429:         # Not using superclass_delegating_reader. See +site+ for explanation
430:         if defined?(@user)
431:           @user
432:         elsif superclass != Object && superclass.user
433:           superclass.user.dup.freeze
434:         end
435:       end
user=(user)

Sets the user for REST HTTP authentication.

       # File activeresource/lib/active_resource/base.rb, line 438
438:       def user=(user)
439:         @connection = nil
440:         @user = user
441:       end
Private Class methods
create_proxy_uri_from(proxy)

Accepts a URI and creates the proxy URI from that.

       # File activeresource/lib/active_resource/base.rb, line 901
901:         def create_proxy_uri_from(proxy)
902:           proxy.is_a?(URI) ? proxy.dup : uri_parser.parse(proxy)
903:         end
create_site_uri_from(site)

Accepts a URI and creates the site URI from that.

       # File activeresource/lib/active_resource/base.rb, line 896
896:         def create_site_uri_from(site)
897:           site.is_a?(URI) ? site.dup : uri_parser.parse(site)
898:         end
find_every(options)

Find every resource

       # File activeresource/lib/active_resource/base.rb, line 846
846:         def find_every(options)
847:           begin
848:             case from = options[:from]
849:             when Symbol
850:               instantiate_collection(get(from, options[:params]))
851:             when String
852:               path = "#{from}#{query_string(options[:params])}"
853:               instantiate_collection(connection.get(path, headers) || [])
854:             else
855:               prefix_options, query_options = split_options(options[:params])
856:               path = collection_path(prefix_options, query_options)
857:               instantiate_collection( (connection.get(path, headers) || []), prefix_options )
858:             end
859:           rescue ActiveResource::ResourceNotFound
860:             # Swallowing ResourceNotFound exceptions and return nil - as per
861:             # ActiveRecord.
862:             nil
863:           end
864:         end
find_one(options)

Find a single resource from a one-off URL

       # File activeresource/lib/active_resource/base.rb, line 867
867:         def find_one(options)
868:           case from = options[:from]
869:           when Symbol
870:             instantiate_record(get(from, options[:params]))
871:           when String
872:             path = "#{from}#{query_string(options[:params])}"
873:             instantiate_record(connection.get(path, headers))
874:           end
875:         end
find_single(scope, options)

Find a single resource from the default URL

       # File activeresource/lib/active_resource/base.rb, line 878
878:         def find_single(scope, options)
879:           prefix_options, query_options = split_options(options[:params])
880:           path = element_path(scope, prefix_options, query_options)
881:           instantiate_record(connection.get(path, headers), prefix_options)
882:         end
instantiate_collection(collection, prefix_options = {})
       # File activeresource/lib/active_resource/base.rb, line 884
884:         def instantiate_collection(collection, prefix_options = {})
885:           collection.collect! { |record| instantiate_record(record, prefix_options) }
886:         end
instantiate_record(record, prefix_options = {})
       # File activeresource/lib/active_resource/base.rb, line 888
888:         def instantiate_record(record, prefix_options = {})
889:           new(record).tap do |resource|
890:             resource.prefix_options = prefix_options
891:           end
892:         end
prefix_parameters()

contains a set of the current prefix parameters.

       # File activeresource/lib/active_resource/base.rb, line 906
906:         def prefix_parameters
907:           @prefix_parameters ||= prefix_source.scan(/:\w+/).map { |key| key[1..1].to_sym }.to_set
908:         end
query_string(options)

Builds the query string for the request.

       # File activeresource/lib/active_resource/base.rb, line 911
911:         def query_string(options)
912:           "?#{options.to_query}" unless options.nil? || options.empty?
913:         end
split_options(options = {})

split an option hash into two hashes, one containing the prefix options, and the other containing the leftovers.

       # File activeresource/lib/active_resource/base.rb, line 917
917:         def split_options(options = {})
918:           prefix_options, query_options = {}, {}
919: 
920:           (options || {}).each do |key, value|
921:             next if key.blank?
922:             (prefix_parameters.include?(key.to_sym) ? prefix_options : query_options)[key.to_sym] = value
923:           end
924: 
925:           [ prefix_options, query_options ]
926:         end
uri_parser()
       # File activeresource/lib/active_resource/base.rb, line 928
928:         def uri_parser
929:           @uri_parser ||= URI.const_defined?(:Parser) ? URI::Parser.new : URI
930:         end
Public Instance methods
==(other)

Test for equality. Resource are equal if and only if other is the same object or is an instance of the same class, is not new?, and has the same id.

Examples

  ryan = Person.create(:name => 'Ryan')
  jamie = Person.create(:name => 'Jamie')

  ryan == jamie
  # => false (Different name attribute and id)

  ryan_again = Person.new(:name => 'Ryan')
  ryan == ryan_again
  # => false (ryan_again is new?)

  ryans_clone = Person.create(:name => 'Ryan')
  ryan == ryans_clone
  # => false (Different id attributes)

  ryans_twin = Person.find(ryan.id)
  ryan == ryans_twin
  # => true
        # File activeresource/lib/active_resource/base.rb, line 1069
1069:     def ==(other)
1070:       other.equal?(self) || (other.instance_of?(self.class) && other.id == id && other.prefix_options == prefix_options)
1071:     end
clone()

Returns a clone of the resource that hasn’t been assigned an id yet and is treated as a new resource.

  ryan = Person.find(1)
  not_ryan = ryan.clone
  not_ryan.new?  # => true

Any active resource member attributes will NOT be cloned, though all other attributes are. This is to prevent the conflict between any prefix_options that refer to the original parent resource and the newly cloned parent resource that does not exist.

  ryan = Person.find(1)
  ryan.address = StreetAddress.find(1, :person_id => ryan.id)
  ryan.hash = {:not => "an ARes instance"}

  not_ryan = ryan.clone
  not_ryan.new?            # => true
  not_ryan.address         # => NoMethodError
  not_ryan.hash            # => {:not => "an ARes instance"}
        # File activeresource/lib/active_resource/base.rb, line 988
 988:     def clone
 989:       # Clone all attributes except the pk and any nested ARes
 990:       cloned = attributes.reject {|k,v| k == self.class.primary_key || v.is_a?(ActiveResource::Base)}.inject({}) do |attrs, (k, v)|
 991:         attrs[k] = v.clone
 992:         attrs
 993:       end
 994:       # Form the new resource - bypass initialize of resource with 'new' as that will call 'load' which
 995:       # attempts to convert hashes into member objects and arrays into collections of objects.  We want
 996:       # the raw objects to be cloned so we bypass load by directly setting the attributes hash.
 997:       resource = self.class.new({})
 998:       resource.prefix_options = self.prefix_options
 999:       resource.send :instance_variable_set, '@attributes', cloned
1000:       resource
1001:     end
destroy()

Deletes the resource from the remote service.

Examples

  my_id = 3
  my_person = Person.find(my_id)
  my_person.destroy
  Person.find(my_id) # 404 (Resource Not Found)

  new_person = Person.create(:name => 'James')
  new_id = new_person.id # => 7
  new_person.destroy
  Person.find(new_id) # 404 (Resource Not Found)
        # File activeresource/lib/active_resource/base.rb, line 1149
1149:     def destroy
1150:       connection.delete(element_path, self.class.headers)
1151:     end
dup()

Duplicates the current resource without saving it.

Examples

  my_invoice = Invoice.create(:customer => 'That Company')
  next_invoice = my_invoice.dup
  next_invoice.new? # => true

  next_invoice.save
  next_invoice == my_invoice # => false (different id attributes)

  my_invoice.customer   # => That Company
  next_invoice.customer # => That Company
        # File activeresource/lib/active_resource/base.rb, line 1096
1096:     def dup
1097:       self.class.new.tap do |resource|
1098:         resource.attributes     = @attributes
1099:         resource.prefix_options = @prefix_options
1100:       end
1101:     end
encode(options={})

Returns the serialized string representation of the resource in the configured serialization format specified in ActiveResource::Base.format. The options applicable depend on the configured encoding format.

        # File activeresource/lib/active_resource/base.rb, line 1176
1176:     def encode(options={})
1177:       send("to_#{self.class.format.extension}", options)
1178:     end
eql?(other)

Tests for equality (delegates to ==).

        # File activeresource/lib/active_resource/base.rb, line 1074
1074:     def eql?(other)
1075:       self == other
1076:     end
exists?()

Evaluates to true if this resource is not new? and is found on the remote service. Using this method, you can check for resources that may have been deleted between the object’s instantiation and actions on it.

Examples

  Person.create(:name => 'Theodore Roosevelt')
  that_guy = Person.find(:first)
  that_guy.exists? # => true

  that_lady = Person.new(:name => 'Paul Bean')
  that_lady.exists? # => false

  guys_id = that_guy.id
  Person.delete(guys_id)
  that_guy.exists? # => false
        # File activeresource/lib/active_resource/base.rb, line 1169
1169:     def exists?
1170:       !new? && self.class.exists?(to_param, :params => prefix_options)
1171:     end
hash()

Delegates to id in order to allow two resources of the same type and id to work with something like:

  [Person.find(1), Person.find(2)] & [Person.find(1), Person.find(4)] # => [Person.find(1)]
        # File activeresource/lib/active_resource/base.rb, line 1080
1080:     def hash
1081:       id.hash
1082:     end
id()

Gets the id attribute of the resource.

        # File activeresource/lib/active_resource/base.rb, line 1038
1038:     def id
1039:       attributes[self.class.primary_key]
1040:     end
id=(id)

Sets the id attribute of the resource.

        # File activeresource/lib/active_resource/base.rb, line 1043
1043:     def id=(id)
1044:       attributes[self.class.primary_key] = id
1045:     end
known_attributes()

This is a list of known attributes for this resource. Either gathered from the provided schema, or from the attributes set on this instance after it has been fetched from the remote system.

       # File activeresource/lib/active_resource/base.rb, line 946
946:     def known_attributes
947:       self.class.known_attributes + self.attributes.keys.map(&:to_s)
948:     end
load(attributes)

A method to manually load attributes from a hash. Recursively loads collections of resources. This method is called in initialize and create when a hash of attributes is provided.

Examples

  my_attrs = {:name => 'J&J Textiles', :industry => 'Cloth and textiles'}
  my_attrs = {:name => 'Marty', :colors => ["red", "green", "blue"]}

  the_supplier = Supplier.find(:first)
  the_supplier.name # => 'J&M Textiles'
  the_supplier.load(my_attrs)
  the_supplier.name('J&J Textiles')

  # These two calls are the same as Supplier.new(my_attrs)
  my_supplier = Supplier.new
  my_supplier.load(my_attrs)

  # These three calls are the same as Supplier.create(my_attrs)
  your_supplier = Supplier.new
  your_supplier.load(my_attrs)
  your_supplier.save
        # File activeresource/lib/active_resource/base.rb, line 1216
1216:     def load(attributes)
1217:       raise ArgumentError, "expected an attributes Hash, got #{attributes.inspect}" unless attributes.is_a?(Hash)
1218:       @prefix_options, attributes = split_options(attributes)
1219:       attributes.each do |key, value|
1220:         @attributes[key.to_s] =
1221:           case value
1222:             when Array
1223:               resource = find_or_create_resource_for_collection(key)
1224:               value.map do |attrs|
1225:                 if attrs.is_a?(Hash)
1226:                   resource.new(attrs)
1227:                 else
1228:                   attrs.duplicable? ? attrs.dup : attrs
1229:                 end
1230:               end
1231:             when Hash
1232:               resource = find_or_create_resource_for(key)
1233:               resource.new(value)
1234:             else
1235:               value.dup rescue value
1236:           end
1237:       end
1238:       self
1239:     end
new?()

Returns true if this object hasn’t yet been saved, otherwise, returns false.

Examples

  not_new = Computer.create(:brand => 'Apple', :make => 'MacBook', :vendor => 'MacMall')
  not_new.new? # => false

  is_new = Computer.new(:brand => 'IBM', :make => 'Thinkpad', :vendor => 'IBM')
  is_new.new? # => true

  is_new.save
  is_new.new? # => false
This method is also aliased as new_record?
        # File activeresource/lib/active_resource/base.rb, line 1016
1016:     def new?
1017:       id.nil?
1018:     end
persisted?()

Returns true if this object has been saved, otherwise returns false.

Examples

  persisted = Computer.create(:brand => 'Apple', :make => 'MacBook', :vendor => 'MacMall')
  persisted.persisted? # => true

  not_persisted = Computer.new(:brand => 'IBM', :make => 'Thinkpad', :vendor => 'IBM')
  not_persisted.persisted? # => false

  not_persisted.save
  not_persisted.persisted? # => true
        # File activeresource/lib/active_resource/base.rb, line 1033
1033:     def persisted?
1034:       !new?
1035:     end
reload()

A method to reload the attributes of this object from the remote web service.

Examples

  my_branch = Branch.find(:first)
  my_branch.name # => "Wislon Raod"

  # Another client fixes the typo...

  my_branch.name # => "Wislon Raod"
  my_branch.reload
  my_branch.name # => "Wilson Road"
        # File activeresource/lib/active_resource/base.rb, line 1191
1191:     def reload
1192:       self.load(self.class.find(to_param, :params => @prefix_options).attributes)
1193:     end
respond_to?(method, include_priv = false)

A method to determine if an object responds to a message (e.g., a method call). In Active Resource, a Person object with a name attribute can answer true to my_person.respond_to?(:name), my_person.respond_to?(:name=), and my_person.respond_to?(:name?).

This method is also aliased as respond_to_without_attributes?
        # File activeresource/lib/active_resource/base.rb, line 1277
1277:     def respond_to?(method, include_priv = false)
1278:       method_name = method.to_s
1279:       if attributes.nil?
1280:         super
1281:       elsif known_attributes.include?(method_name)
1282:         true
1283:       elsif method_name =~ /(?:=|\?)$/ && attributes.include?($`)
1284:         true
1285:       else
1286:         # super must be called at the end of the method, because the inherited respond_to?
1287:         # would return true for generated readers, even if the attribute wasn't present
1288:         super
1289:       end
1290:     end
save()

Saves (POST) or updates (PUT) a resource. Delegates to create if the object is new, update if it exists. If the response to the save includes a body, it will be assumed that this body is XML for the final object as it looked after the save (which would include attributes like created_at that weren’t part of the original submit).

Examples

  my_company = Company.new(:name => 'RoleModel Software', :owner => 'Ken Auer', :size => 2)
  my_company.new? # => true
  my_company.save # sends POST /companies/ (create)

  my_company.new? # => false
  my_company.size = 10
  my_company.save # sends PUT /companies/1 (update)
        # File activeresource/lib/active_resource/base.rb, line 1116
1116:     def save
1117:       new? ? create : update
1118:     end
save!()

Saves the resource.

If the resource is new, it is created via POST, otherwise the existing resource is updated via PUT.

With save! validations always run. If any of them fail ActiveResource::ResourceInvalid gets raised, and nothing is POSTed to the remote system. See ActiveResource::Validations for more information.

There’s a series of callbacks associated with save!. If any of the before_* callbacks return false the action is cancelled and save! raises ActiveResource::ResourceInvalid.

        # File activeresource/lib/active_resource/base.rb, line 1133
1133:     def save!
1134:       save || raise(ResourceInvalid.new(self))
1135:     end
schema()

If no schema has been defined for the class (see ActiveResource::schema=), the default automatic schema is generated from the current instance’s attributes

       # File activeresource/lib/active_resource/base.rb, line 939
939:     def schema
940:       self.class.schema || self.attributes
941:     end
to_json(options={})
        # File activeresource/lib/active_resource/base.rb, line 1292
1292:     def to_json(options={})
1293:       super({ :root => self.class.element_name }.merge(options))
1294:     end
to_xml(options={})
        # File activeresource/lib/active_resource/base.rb, line 1296
1296:     def to_xml(options={})
1297:       super({ :root => self.class.element_name }.merge(options))
1298:     end
update_attribute(name, value)

Updates a single attribute and then saves the object.

Note: Unlike ActiveRecord::Base.update_attribute, this method is subject to normal validation routines as an update sends the whole body of the resource in the request. (See Validations).

As such, this method is equivalent to calling update_attributes with a single attribute/value pair.

If the saving fails because of a connection or remote service error, an exception will be raised. If saving fails because the resource is invalid then false will be returned.

        # File activeresource/lib/active_resource/base.rb, line 1252
1252:     def update_attribute(name, value)
1253:       self.send("#{name}=".to_sym, value)
1254:       self.save
1255:     end
update_attributes(attributes)

Updates this resource with all the attributes from the passed-in Hash and requests that the record be saved.

If the saving fails because of a connection or remote service error, an exception will be raised. If saving fails because the resource is invalid then false will be returned.

Note: Though this request can be made with a partial set of the resource’s attributes, the full body of the request will still be sent in the save request to the remote service.

        # File activeresource/lib/active_resource/base.rb, line 1267
1267:     def update_attributes(attributes)
1268:       load(attributes) && save
1269:     end
Protected Instance methods
collection_path(options = nil)
        # File activeresource/lib/active_resource/base.rb, line 1339
1339:       def collection_path(options = nil)
1340:         self.class.collection_path(options || prefix_options)
1341:       end
connection(refresh = false)
        # File activeresource/lib/active_resource/base.rb, line 1301
1301:       def connection(refresh = false)
1302:         self.class.connection(refresh)
1303:       end
create()

Create (i.e., save to the remote service) the new resource.

        # File activeresource/lib/active_resource/base.rb, line 1313
1313:       def create
1314:         connection.post(collection_path, encode, self.class.headers).tap do |response|
1315:           self.id = id_from_response(response)
1316:           load_attributes_from_response(response)
1317:         end
1318:       end
element_path(options = nil)
        # File activeresource/lib/active_resource/base.rb, line 1331
1331:       def element_path(options = nil)
1332:         self.class.element_path(to_param, options || prefix_options)
1333:       end
id_from_response(response)

Takes a response from a typical create post and pulls the ID out

        # File activeresource/lib/active_resource/base.rb, line 1327
1327:       def id_from_response(response)
1328:         response['Location'][/\/([^\/]*?)(\.\w+)?$/, 1] if response['Location']
1329:       end
load_attributes_from_response(response)
        # File activeresource/lib/active_resource/base.rb, line 1320
1320:       def load_attributes_from_response(response)
1321:         if response['Content-Length'] != "0" && response.body.strip.size > 0
1322:           load(self.class.format.decode(response.body))
1323:         end
1324:       end
new_element_path()
        # File activeresource/lib/active_resource/base.rb, line 1335
1335:       def new_element_path
1336:         self.class.new_element_path(prefix_options)
1337:       end
update()

Update the resource on the remote service.

        # File activeresource/lib/active_resource/base.rb, line 1306
1306:       def update
1307:         connection.put(element_path(prefix_options), encode, self.class.headers).tap do |response|
1308:           load_attributes_from_response(response)
1309:         end
1310:       end
Private Instance methods
find_or_create_resource_for(name)

Tries to find a resource for a given name; if it fails, then the resource is created

        # File activeresource/lib/active_resource/base.rb, line 1364
1364:       def find_or_create_resource_for(name)
1365:         resource_name = name.to_s.camelize
1366:         ancestors = self.class.name.split("::")
1367:         if ancestors.size > 1
1368:           find_resource_in_modules(resource_name, ancestors)
1369:         else
1370:           self.class.const_get(resource_name)
1371:         end
1372:       rescue NameError
1373:         if self.class.const_defined?(resource_name)
1374:           resource = self.class.const_get(resource_name)
1375:         else
1376:           resource = self.class.const_set(resource_name, Class.new(ActiveResource::Base))
1377:         end
1378:         resource.prefix = self.class.prefix
1379:         resource.site   = self.class.site
1380:         resource
1381:       end
find_or_create_resource_for_collection(name)

Tries to find a resource for a given collection name; if it fails, then the resource is created

        # File activeresource/lib/active_resource/base.rb, line 1345
1345:       def find_or_create_resource_for_collection(name)
1346:         find_or_create_resource_for(ActiveSupport::Inflector.singularize(name.to_s))
1347:       end
find_resource_in_modules(resource_name, module_names)

Tries to find a resource in a non empty list of nested modules Raises a NameError if it was not found in any of the given nested modules

        # File activeresource/lib/active_resource/base.rb, line 1351
1351:       def find_resource_in_modules(resource_name, module_names)
1352:         receiver = Object
1353:         namespaces = module_names[0, module_names.size-1].map do |module_name|
1354:           receiver = receiver.const_get(module_name)
1355:         end
1356:         if namespace = namespaces.reverse.detect { |ns| ns.const_defined?(resource_name) }
1357:           return namespace.const_get(resource_name)
1358:         else
1359:           raise NameError
1360:         end
1361:       end
split_options(options = {})
        # File activeresource/lib/active_resource/base.rb, line 1383
1383:       def split_options(options = {})
1384:         self.class.__send__(:split_options, options)
1385:       end